package pi7;

import java.util.List;
import pi7.GcodeParser.FimprogramaContext;
import pi7.GcodeParser.GcodfuncContext;
import pi7.GcodeParser.MfuncContext;
import pi7.GcodeParser.StatementContext;

public class GcodeProcessor extends GcodeBaseVisitor {
    List<LinhaPrograma> programaNC = null;
    
    @Override
    public Object visitStatement(StatementContext ctx) {
        LinhaPrograma linha = new LinhaPrograma();
        // linha com funcao G
        GcodfuncContext gcodfunc = ctx.gcodfunc();
        if (gcodfunc != null) {
            linha.codigoG = gcodfunc.getText();
            linha.codigoM = null;
            linha.x = ctx.coordx().coord().getText();
            linha.y = ctx.coordy().coord().getText();
            linha.numeroLinha = ctx.numerolinha().getText();
            programaNC.add(linha);
        } 
        
        // linha com funcao M
        MfuncContext mcodfunc = ctx.mfunc();
        if (mcodfunc != null) {
            linha.codigoM = mcodfunc.getText();
            linha.codigoG = null;
            linha.numeroLinha = ctx.numerolinha().getText();
            programaNC.add(linha);
        }
        return super.visitStatement(ctx);
    } // visitStatement

    @Override
    public Object visitFimprograma(FimprogramaContext ctx) {
        LinhaPrograma linha = new LinhaPrograma();
        linha.codigoM = ctx.mfim().getText();
        linha.codigoG = null;
        linha.numeroLinha = ctx.numerolinha().getText();
        programaNC.add(linha);
        return super.visitFimprograma(ctx);
    }

    public GcodeProcessor(List<LinhaPrograma> programa) {
        this.programaNC = programa;
    } // constructor
    
} 